<?php
// 应用公共文件

function __autoload($class){
    if(file_exists($GLOBALS['config']['socket_controller'].$class.'.php')) {
        require_once($GLOBALS['config']['socket_controller'].$class.'.php');
    }else{
        echo_log("找不到对应的文件: $class ".__LINE__);
    }
}

function echo_log($data,$data2=''){
	//如果打开了调试
	if(is_array($data) || is_object($data)) {
		var_dump(date("Y-m-d H:i ") . $data);
	} else {
		echo(date("Y-m-d H:i ") . $data);
	}
	echo("\r\n");
	if (!empty($data2)) {
		if(is_array($data2) || is_object($data2)) {
			var_dump(date("Y-m-d H:i ") . $data2);
		} else {
			echo($data2);
		}
	}
	echo("\r\n\r\n");
}

function post_curl($url,$data,$header = array(), $is_ssl = false) {

	$ch = curl_init(); // 启动一个CURL会话
	curl_setopt($ch, CURLOPT_URL, $url); // 要访问的地址
	if ($is_ssl) {
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // 对认证证书来源的检查
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2); // 从证书中检查SSL加密算法是否存在
		curl_setopt($ch, CURLOPT_SSLVERSION, 1); // 设定SSL版本,微信时候使用1，否则报错
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	}
	if ($data) {
		curl_setopt($ch, CURLOPT_POST, 1); // 发送一个常规的Post请求
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data); // Post提交的数据包
	}
	$header[]= "Sercet: edf_a3d1bf7760f3485aa2f7bd4a3124db71";
	$header[]= "Time: ".date('YmdHis');
	if ($header) {
		curl_setopt($ch,CURLOPT_HTTPHEADER,$header);
	}
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // 获取的信息以文件流的形式返回

	$out = curl_exec($ch);
	$outArr = json_decode($out, true);
	if($outArr) {
		return $outArr;
	} else {
		return $out;
	}

}

function cache($config) {
	$con = new Redis();
	$con->connect($config['host'], $config['port']);
	if(!empty($config['auth'])){
		$this->auth($config['auth']);
	}
	return $con;
}

//解码(主要针对特殊符号和emoji表情)
function emoji_decode($str){
    if(empty($str)){
        return $str;
    }
    $str = preg_replace_callback('/@E(.{6}==)/', function ($r) {
        return base64_decode($r[1]);
    }, $str);
    return $str;
}

function createLoginToken($data)
{
    $arr = json_encode($arr);
    return base64_encode(uc_authcode($arr, 'ENCODE'));
}

function decryptToken($token)
{
    if($token){
        $val = uc_authcode(base64_decode($token),'DECODE');
        if(!empty($val)){
            $val = json_decode($val,true);
        }else{
            $val = false;
        }
        return $val;
    }else{
        return false;
    }
}

/***********************************socket公用方法start********************************************************/
//根据用户ID查用户的连接记录
function get_user_fd($uid){
	if($GLOBALS['USER_LIST']->exist($uid)){
		$tmp_val = $GLOBALS['USER_LIST']->get($uid);
		return $tmp_val['fd'];
	}else{
		return false;
	}
}
//根据用户的fd查用户的uid
function get_user_uid($fd){
	if($GLOBALS['USER_LIST_FD']->exist($fd)){
		$tmp_val = $GLOBALS['USER_LIST_FD']->get($fd);
		return $tmp_val['uid'];
	}else{
		return false;
	}
}

//设置用户在线
/*
$data = array(
	"fd"		=> ,//"连接",
	"uid"		=> ,//用户ID,
);
*/
function set_user_list($data){
	//删掉这个uid之前绑定的连接
	$tmp_uid = $GLOBALS['USER_LIST']->get($data['uid']);
	if($tmp_uid && $tmp_uid['fd']>0){
		$GLOBALS['USER_LIST_FD']->del($tmp_uid['fd']);
		$GLOBALS['USER_LIST']->del($data['uid']);
	}
	$GLOBALS['USER_LIST']->set($data['uid'],array('fd'=>$data['fd']));
	$GLOBALS['USER_LIST_FD']->set($data['fd'],array('uid'=>$data['uid']));
	return true;
}

//删除用户在线数据
function del_user_list($fd){
	$GLOBALS['USER_LIST']->del(get_user_uid($fd));
	$GLOBALS['USER_LIST_FD']->del($fd);
	return true;
}

//给某个用户发信息
function send_user($server,$uid,$data,$opcode=1,$finish=true){
	if(empty($uid)){
		return false;
	}
	$fd = get_user_fd($uid);
	//检测通道是否存在
	if(!empty($fd) && !$server->exist($fd)){
		echo_log("通道[ $fd ]的客户端已经断开,无法发送消息!\r\n",$data);
		unset($data);
		return false;
	}else{
		$server->push($fd,$data,$opcode,$finish);
		unset($data);
		return $finish;
	}
}

//给指定用户发信息（群发）
function send_group($server,$arr,$data,$opcode=1){
	if(!empty($arr)){
		foreach($arr as $uid){
			if(send_user($server,$uid,$data,$opcode)){
				echo_log('用户['. $uid .']发送消息成功!\r\n');
			}else{
				echo_log('用户['. $uid .']的客户端已经断开,无法发送消息!\r\n');
			}
		}
	}else{
		echo_log('没有指定要发信息的用户,无法发送消息!\r\n');
	}
	return true;
}

//给所有用户发信息
function send_all($server,$data,$opcode=1,$finish=true){
	if(!empty($GLOBALS['USER_LIST'])){
		foreach($GLOBALS['USER_LIST'] as $fd){
			$server->push($fd['fd'],$data,$opcode,$finish);
			if($finish){
				echo_log('用户['. $fd['fd'] .']发送消息成功!\r\n');
			}else{
				echo_log('用户['. $fd['fd'] .']的客户端已经断开,无法发送消息!\r\n');
			}
		}
	}else{
		echo_log('没有指定要发信息的用户,无法发送消息!\r\n');
	}
	return true;
}
/***********************************socket公用方法end********************************************************/