<?php
require_once ROOT_PATH."application/common.php";//公共方法
require_once ROOT_PATH."extend/mysql/Connection.php";//mysql方法

class socketWork {
	
	public $server;
	
	public function __construct($server) {
		$this->server = $server;
		//链接数据库
		$GLOBALS['redisDB'] = cache($GLOBALS['config']['REDIS']);
		$GLOBALS['mysqlDB'] = new \Workerman\MySQL\Connection($GLOBALS['config']['MYSQL']['DB_HOST'], $GLOBALS['config']['MYSQL']['DB_PORT'], $GLOBALS['config']['MYSQL']['DB_USER'], $GLOBALS['config']['MYSQL']['DB_PWD'], $GLOBALS['config']['MYSQL']['DB_NAME']);
	}  
	
	public function onWorkerStop( $server , $worker_id) {
		if ($GLOBALS['redisDB']) {
			$GLOBALS['redisDB']->close();
		}
		if ($GLOBALS['mysqlDB']) {
			$GLOBALS['mysqlDB']->closeConnection();
		}
    }   

	public function onWorkerError( $server , $worker_id) {
		echo _log('work进程报错');
    }

	public function onOpen($server, $frame) {

		$uid = 'fd'.$frame->fd;
		set_user_list(array('fd'=>$frame->fd,'uid'=>$uid));
		$reData = json_encode(array('c'=>1,'msg'=>'websocket连接成功','d'=>array('uid'=>$uid)));
		$server->push($frame->fd, $reData);
		
	}

	public function onMessage($server, $frame) {
		$data = json_decode($frame->data,true);
		
		// $path = 'application/socket/'.$data['m'].'.php';
		if (class_exists($data['m'])) {

			$data['fd']     = $frame->fd;
			$data['ip']     = $this->server->connections[$frame->fd]['remote_ip'];
			
			$tmp_task_id = $this->server->task($data);
            echo_log("进行task任务:".$tmp_task_id);
		}else{
			$this->server->push($frame->fd, json_encode(array('c'=>2,'msg'=>'找不到对应的模块')));
		}
	}

	public function onRequest($server, $request, $response) {
		$event = $request->get['event'];
		if($event == 'reload') {
			$server->reload();
			$response->write('reload success');
		} else if($event == 'send_msg') {
			//通过uid给用户发送消息
			$act = new user();
			$data = array(
				'server'=>$server
				,'d'=>$request->post
			);
			$act->setData($data);
			$result = $act->send_msg();

			$response->write($result);
		} else {
			//默认返回
			$response->write('websocket response');
		}
	}
	
	public function onTask($server, $task_Id, $worker_id, $data) {
		echo_log("进行task任务:".$task_Id.'开始工作');

		$act = new $data['m']();
		//是否有这个方法在
		if (!method_exists($act, $data['a'])) {
			$this->server->push($data['fd'], json_encode(array('c'=>2,'msg'=>'找不到对应的方法')));
			$this->server->finish($task_Id);
            return false;
		} else {
			$data['server'] = $server;
			if($act->setData($data)){
				echo_log("执行情况：".$act->{$data['a']}() );
				$this->server->finish($task_Id);
				return true;
			}else{
				echo_log("执行出错：".$data['m']."->".$data['a']."\r\n");
				$this->server->finish($task_Id);
				return false;
			}
		}

	}
	
	public function onFinish($server,$task_Id, $data) {
		echo_log("进行task任务:".$task_Id.'工作完成');
	}
	
	public function onClose($server, $fd) {
		del_user_list($fd);
		echo_log('client'.$fd.'下线');
	}
	

	

}